/*
 * GluonJ, An Aspect-Oriented Programming System for Java.
 * Copyright (C) 2006 Shigeru Chiba. All Rights Reserved.
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License.  Alternatively, the contents of this file may be used under
 * the terms of the GNU Lesser General Public License Version 2.1 or later.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 */
package javassist.gluonj.pc;

import javassist.gluonj.WeaveException;

public class OrPc extends PointcutNode {
    private PointcutNode head;
    private OrPc tail;

    public OrPc(PointcutNode head, OrPc tail) {
        this.head = head;
        this.tail = tail;
    }

    public PointcutNode first() { return head; }
    public OrPc rest() { return tail; }

    public void accept(PointcutVisitor v) throws WeaveException {
        v.visit(this);
    }

    public String toString() {
        StringBuffer sbuf = new StringBuffer();
        sbuf.append('(');
        sbuf.append(head.toString());
        OrPc rest = tail;
        while (rest != null) {
            sbuf.append(" || ");
            sbuf.append(rest.head.toString());
            rest = rest.tail;
        }

        sbuf.append(')');
        return sbuf.toString();
    }
}
