package javassist.gluonj.weave;

import javassist.expr.Expr;
import javassist.expr.MethodCall;
import javassist.gluonj.WeaveException;
import javassist.gluonj.pc.CallPc;
import javassist.gluonj.util.SimplePcNode;

/**
 * A Matcher customized for call join points.
 */
public class CallMatcher extends ExprMatcher {
    protected MethodCall joinPoint;
    protected String declClass;
    protected String name, descriptor;

    public CallMatcher(MethodCall mc) {
        super(mc.where());
        joinPoint = mc;
        declClass = mc.getClassName();
        name = mc.getMethodName();
        descriptor = mc.getSignature();
    }

    public Expr getJoinPoint() {
        return joinPoint;
    }

    public void visit(CallPc pc) throws WeaveException {
        result = pc.getPattern().matchMethod(declClass, name, descriptor);
    }

    public void visit(SimplePcNode pc) throws WeaveException {
        Residue[] r = new Residue[1];
        result = pc.match(joinPoint, r);
        residue = r[0];
    }
}
