package javassist.gluonj.weave;

import javassist.expr.NewExpr;
import javassist.expr.Expr;
import javassist.gluonj.WeaveException;
import javassist.gluonj.pc.CallPc;
import javassist.gluonj.util.SimplePcNode;

/**
 * A Matcher customized for object-creation join points.
 */
public class NewMatcher extends ExprMatcher {
    private NewExpr joinPoint;
    private String declClass;
    private String name, descriptor;

    public NewMatcher(NewExpr expr) {
        super(expr.where());
        joinPoint = expr;
        declClass = expr.getClassName();
        name = AdviceWeaver.CONSTRUCTOR;
        descriptor = expr.getSignature();
    }

    public Expr getJoinPoint() {
        return joinPoint;
    }

    public void visit(CallPc pc) throws WeaveException {
        result = pc.getPattern().matchMethod(declClass, name, descriptor);
    }

    public void visit(SimplePcNode pc) throws WeaveException {
        Residue[] r = new Residue[1];
        result = pc.match(joinPoint, r);
        residue = r[0];
    }
}
